'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ActionMenu = function (_Component) {
	_inherits(ActionMenu, _Component);

	function ActionMenu(props) {
		_classCallCheck(this, ActionMenu);

		var _this = _possibleConstructorReturn(this, (ActionMenu.__proto__ || Object.getPrototypeOf(ActionMenu)).call(this, props));

		_this.state = {
			dropdownLabel: _this.props.startValue,
			isOpen: false,
			selectedOption: ''
		};

		_this.handleOpen = _this.handleOpen.bind(_this);
		_this.handleSelection = _this.handleSelection.bind(_this);
		return _this;
	}

	_createClass(ActionMenu, [{
		key: 'handleOpen',
		value: function handleOpen(openEvent) {
			this.setState({ isOpen: !this.state.isOpen });
			// this.setState({ isOpen: true });
		}
	}, {
		key: 'handleSelection',
		value: function handleSelection(selectionEvent) {
			this.setState({
				dropdownLabel: selectionEvent.target.getAttribute('data-label'),
				isOpen: false,
				selectedOption: selectionEvent.target.value
			}, this.props.onChange(selectionEvent));
		}
	}, {
		key: 'render',
		value: function render() {
			var id = this.props.id;
			var _state = this.state,
			    isOpen = _state.isOpen,
			    dropdownLabel = _state.dropdownLabel;


			return _react2.default.createElement(
				'div',
				{ id: id,
					tabIndex: '0',
					className: 'cp-DropdownMenu ' + (isOpen ? 'is-open' : ''),
					'data-label': dropdownLabel,
					onClick: this.handleOpen },
				_react2.default.createElement(
					'svg',
					{ className: 'cp-DropdownMenu-arrow--down' },
					_react2.default.createElement('use', { xmlnsXlink: 'http://www.w3.org/1999/xlink', xlinkHref: '#iconArrow--down' })
				),
				isOpen && this.renderMenu(this.handleSelection)
			);
		}
	}, {
		key: 'renderMenu',
		value: function renderMenu(handleSelection) {
			var _props = this.props,
			    id = _props.id,
			    options = _props.options;
			var selectedOption = this.state.selectedOption;


			return _react2.default.createElement(
				'div',
				{ className: 'cp-DropdownMenu-menu' },
				options.map(function (optionName, index) {
					var optionId = id + 'Option' + index;
					return _react2.default.createElement(
						'div',
						{ key: index },
						_react2.default.createElement('input', { id: optionId,
							value: optionId,
							name: id + "Options",
							'data-label': optionName,
							type: 'radio',
							className: 'cp-RadioButton-input',
							checked: selectedOption === optionId,
							onChange: handleSelection }),
						_react2.default.createElement(
							'label',
							{ htmlFor: optionId,
								className: 'cp-RadioButton-label cp-DropdownMenu-option' },
							optionName
						)
					);
				})
			);
		}
	}]);

	return ActionMenu;
}(_react.Component);

exports.default = ActionMenu;